/***************************************************************************
 *	ggxcnv.c - ɥǥХ I/O 桼ƥƥؿ
 *										for ggxsnd Version 0.8.0
 *	
 *			Date 1999/05/18 -- 
 *					Programmed by Nobuyuki Maruichi
 *	
 *		ˡС򰷤
 *	ª
 *		ܸ EUC
 *		Tab Size 4 / Shift Width = 4
 *		
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

/***************************************
 * ggxsnd ѤΥ󥯥롼ɡե
 ***************************************/
#include "stringuty.h"
#include "ggxsnd.h"

static const String XggNwrongParameters = "wrongParameters";

/* from /xc/lib/Xt/Converters.c and X Toolkit Intrinsics Reference Manual. */
#define	done(type, value) \
	{							\
	    if (toVal->addr != NULL) {				\
		if (toVal->size < sizeof(type)) {		\
		    toVal->size = sizeof(type);			\
		    return False;				\
		}						\
		*(type*)(toVal->addr) = (value);		\
	    }							\
	    else {						\
		static type static_val;				\
		static_val = (value);				\
		toVal->addr = (XPointer)&static_val;		\
	    }							\
	    toVal->size = sizeof(type);				\
	    return True;					\
	}

/***************************************************************************
 *	XggTypeConverter: ʸ󤫤饵ɥǥХˡѴ
 *	
 *		Boolean XggTypeConverter(Display *dpy, 
 *			XrmValue *args, Cardinal *num_args, 
 *			XrmValue *fromVal, XrmValue *toVal, XtPointer *converter_data);
 *	
 *		Display *dpy;			ѴԤǥץ쥤
 *		XrmValue *args;			СФɲäΰ̤ѡ
 *		Cardinal *num_args;		args ΰο
 *		XrmValue *fromVal;		СȤ븵ͤΥɥ쥹礭
 *		XrmValue *toVal;		СȤͤΥɥ쥹礭
 *		XtPointer *converter_data;	̤ѡ
 *	֤
 *		False:		Ѵ˼
 *		True:		Ѵ
 *	
 *		
 ***************************************************************************/
Boolean XggTypeConverter(Display *dpy, XrmValue *args, Cardinal *num_args, 
				XrmValue *fromVal, XrmValue *toVal, XtPointer *converter_data)
{
	int result = EOF;	/* ϡioType  */
	String target = (String)fromVal->addr;
	static const char *ioTypeNames[] = {"pcm8towns", "pcm16towns", NULL};

	if(*num_args != 1) {
		result = searchInStringPointerArray(target, ioTypeNames, asciiStringCaseCmp);
	}
	if(result == EOF) {
		XtAppWarningMsg(XtDisplayToApplicationContext(dpy),
				XggNwrongParameters, "XggTypeConverter", XggCIoType,
							"Cannot conver string to Audio I/O type",
										(String *)NULL, (Cardinal *)NULL);
		return(False);
	}
	done(int, result);
}

